VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "www.ActiveVB.de - LoadIconFromLibrary"
   ClientHeight    =   3675
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4275
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3675
   ScaleWidth      =   4275
   StartUpPosition =   2  'Bildschirmmitte
   Begin MSComctlLib.ImageList ilsIcons 
      Left            =   2160
      Top             =   2040
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      MaskColor       =   12632256
      _Version        =   393216
   End
   Begin MSComctlLib.ListView lvSample 
      Height          =   2535
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   2655
      _ExtentX        =   4683
      _ExtentY        =   4471
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

' Autor:  Herfried Karl Wagner <Hirf@ActiveVB.de>

' Hinweis: Hier wird LoadIcon demonstriert. Das selbe geht natrlich auch mit
'          LoadCursor und LoadImage

Option Explicit

Private Declare Function LoadIcon Lib "user32.dll" Alias "LoadIconA" _
    (ByVal hInstance As Long, ByVal lpIconName As String) As Long
    
Private Declare Function LoadLibrary Lib "kernel32.dll" Alias "LoadLibraryA" _
    (ByVal lpLibFileName As String) As Long
    
Private Declare Function FreeLibrary Lib "kernel32.dll" _
    (ByVal hLibModule As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" _
    (ByRef lpDest As Any, ByRef lpSource As Any, ByVal nCount As Long)

Private Const ERROR_SUCCESS As Long = 0&

Private Type PictDesc
    cbSizeofStruct As Long
    picType As Long
    hImage As Long
    xExt As Long
    yExt As Long
End Type

Private Type Guid
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" _
    (ByRef lpPictDesc As PictDesc, ByRef riid As Guid, _
    ByVal fPictureOwnsHandle As Long, ByRef ipic As IPicture) As Long

Private Sub Form_Load()
    Dim strFilename As String
    ' Dateiname der DLL (Kann z.B: eine in C geschrieben Ressourcendatei sein)
    strFilename = "SHELL32.DLL"
    'strFilename = "C:\WINDOWS\SYSTEM\SHELL32.DLL"
    'strFilename = "C:\WINDOWS\SYSTEM32\SHELL32.DLL"
    Dim h As Long
    h = LoadLibrary(strFilename)
    If h = ERROR_SUCCESS Then
        MsgBox "DLL """ & strFilename & """ konnte nicht geladen werden!", _
            vbExclamation, App.Title
    Else
        Dim hIcon As Long
        Dim lngIconNumber As Long
        ' Die Icon nummer in der Ressource
        lngIconNumber = 1
        hIcon = LoadIcon(h, MAKEINTRESOURCE(lngIconNumber))
        If hIcon = ERROR_SUCCESS Then
             MsgBox "Fehler beim Laden des Icons mit Nummer " & _
                    CStr(lngIconNumber) & " aus """ & strFilename & """!", _
                    vbExclamation, App.Title
        Else
            ' Icon Anzeigen
            Call ilsIcons.ListImages.Add(1, "ICON_" & lngIconNumber, IconToPicture(hIcon))
            Set lvSample.Icons = ilsIcons
            Call lvSample.ListItems.Add(1, "ITEM_" & lngIconNumber, "Icon " & lngIconNumber, 1)
        End If
        Call FreeLibrary(h)
    End If
End Sub

Public Function IconToPicture(ByVal hIcon As Long) As IPicture
    ' Icon in Picture umwandeln
    If hIcon = 0 Then
        Exit Function
    End If
    Dim oNewPic As Picture
    Dim tPicConv As PictDesc
    Dim IGuid As Guid
    With tPicConv
        .cbSizeofStruct = Len(tPicConv)
        .picType = vbPicTypeIcon
        .hImage = hIcon
    End With
    
    ' Fill in magic IPicture GUID {7BF80980-BF32-101A-8BBB-00AA00300CAB}.
    With IGuid
        .Data1 = &H7BF80980
        .Data2 = &HBF32
        .Data3 = &H101A
        .Data4(0) = &H8B
        .Data4(1) = &HBB
        .Data4(2) = &H0
        .Data4(3) = &HAA
        .Data4(4) = &H0
        .Data4(5) = &H30
        .Data4(6) = &HC
        .Data4(7) = &HAB
    End With
    Call OleCreatePictureIndirect(tPicConv, IGuid, True, oNewPic)
    Set IconToPicture = oNewPic
End Function

Public Function MAKEINTRESOURCE(ByVal lID As Long) As String
    MAKEINTRESOURCE = "#" & CStr(MAKELONG(lID, 0))
End Function

Public Function LOWORD(ByVal dwValue As Long) As Long
    Call CopyMemory(LOWORD, dwValue, 2)
End Function

Public Function MAKELONG(ByVal wLow As Long, ByVal wHi As Long) As Long
    If (wHi And &H8000&) Then
        MAKELONG = (((wHi And &H7FFF&) * 65536) Or (wLow And &HFFFF&)) Or &H80000000
    Else
        MAKELONG = LOWORD(wLow) Or (&H10000 * LOWORD(wHi))
    End If
End Function
